#ifndef __SERIALPORT_H__
#define __SERIALPORT_H__

#define FC_DTRDSR       0x01
#define FC_RTSCTS       0x02
#define FC_XONXOFF      0x04
#define ASCII_BEL       0x07
#define ASCII_BS        0x08
#define ASCII_LF        0x0A
#define ASCII_CR        0x0D
#define ASCII_XON       0x11
#define ASCII_XOFF      0x13

#include <assert.h>
#include <windows.h>
#include <stdio.h>
#include <string.h>

class CSerialPort
{														 
public:
	// contruction and destruction
	CSerialPort();
	~CSerialPort();
	bool OpenSerialPort(int iPort, int iBaud);
	bool CloseSerialPort(void);
	int ReadDataWaiting( void );
	int ReadData( void *buffer, int limit );
	bool WriteCommByte( unsigned char ucByte );
	int SendData( const char *buffer, int size );

	OVERLAPPED m_OverlappedRead;
	OVERLAPPED m_OverlappedWrite;
	HANDLE m_hIDComDev;
	bool m_bOpened;
	DWORD dwEvtMask;

protected:

};

#endif



