#include "stdafx.h"
#include <stdio.h>
#include <string.h>
#include <windows.h>
#include "thread.h"

Thread* pThread=NULL; // 	create pointers on class Thread

Thread::Thread() // constructor
{
	status = STOPPED;
	pThread = this;
    m_callback = NULL;
}

Thread::~Thread()
{
	if (status == RUNNING)
	{
		stop();
	}
}

void Thread::start()
{
	if (status == RUNNING) 
	{
		// Thread is running 
		return;
	}
	else
	{
		// Thread is starting
		status = RUNNING;
		hThread = CreateThread(NULL, Thread_STACK_SIZE, my_Thread, this, 0, &dwThreadID);
	}
}

void Thread::stop()
{
	if (status == RUNNING)
	{
		status = STOPPED;
		TerminateThread(hThread, dwThreadID);
	}
}

void Thread::SetThreadCallBack(void* callback)
{
m_callback = callback;
}


// static memberfunction, this function start the virtual function
DWORD WINAPI Thread::my_Thread(void* para)
{
    Thread* pthis=(Thread*)para;
	if(pthis!=NULL)
	{
		pthis->ThreadFunction(pthis->m_callback);
		return 0;
	}
	return -1;
}
